diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/post.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/post.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 52,72 ****
  
  	register_post_type( 'attachment', array(
  		'labels' => array(
! 			'name' => __( 'Media' ),
! 			'edit_item' => __( 'Edit Media' ),
  		),
  		'public' => true,
! 		'show_ui' => false,
  		'_builtin' => true, /* internal use only. don't use this when registering your own post type. */
! 		'_edit_link' => 'media.php?attachment_id=%d', /* internal use only. don't use this when registering your own post type. */
  		'capability_type' => 'post',
  		'map_meta_cap' => true,
  		'hierarchical' => false,
  		'rewrite' => false,
  		'query_var' => false,
  		'show_in_nav_menus' => false,
  		'delete_with_user' => true,
! 		'supports' => array( 'comments', 'author' ),
  	) );
  
  	register_post_type( 'revision', array(
--- 52,78 ----
  
  	register_post_type( 'attachment', array(
  		'labels' => array(
! 			'name' => _x('Media', 'post type general name'),
! 			'name_admin_bar' => _x( 'Media', 'add new from admin bar' ),
! 			'add_new' => _x( 'Add New', 'add new media' ),
!  			'edit_item' => __( 'Edit Media' ),
!  			'view_item' => __( 'View Attachment Page' ),
  		),
  		'public' => true,
! 		'show_ui' => true,
  		'_builtin' => true, /* internal use only. don't use this when registering your own post type. */
! 		'_edit_link' => 'post.php?post=%d', /* internal use only. don't use this when registering your own post type. */
  		'capability_type' => 'post',
+ 		'capabilities' => array(
+ 			'create_posts' => 'upload_files',
+ 		),
  		'map_meta_cap' => true,
  		'hierarchical' => false,
  		'rewrite' => false,
  		'query_var' => false,
  		'show_in_nav_menus' => false,
  		'delete_with_user' => true,
! 		'supports' => array( 'title', 'author', 'comments' ),
  	) );
  
  	register_post_type( 'revision', array(
***************
*** 204,212 ****
  		return false;
  
  	$file = apply_filters( 'update_attached_file', $file, $attachment_id );
! 	$file = _wp_relative_upload_path($file);
! 
! 	return update_post_meta( $attachment_id, '_wp_attached_file', $file );
  }
  
  /**
--- 210,219 ----
  		return false;
  
  	$file = apply_filters( 'update_attached_file', $file, $attachment_id );
! 	if ( $file = _wp_relative_upload_path( $file ) )
! 		return update_post_meta( $attachment_id, '_wp_attached_file', $file );
! 	else
! 		return delete_post_meta( $attachment_id, '_wp_attached_file' );
  }
  
  /**
***************
*** 223,233 ****
  function _wp_relative_upload_path( $path ) {
  	$new_path = $path;
  
! 	if ( ($uploads = wp_upload_dir()) && false === $uploads['error'] ) {
! 		if ( 0 === strpos($new_path, $uploads['basedir']) ) {
! 				$new_path = str_replace($uploads['basedir'], '', $new_path);
! 				$new_path = ltrim($new_path, '/');
! 		}
  	}
  
  	return apply_filters( '_wp_relative_upload_path', $new_path, $path );
--- 230,239 ----
  function _wp_relative_upload_path( $path ) {
  	$new_path = $path;
  
! 	$uploads = wp_upload_dir();
! 	if ( 0 === strpos( $new_path, $uploads['basedir'] ) ) {
! 			$new_path = str_replace( $uploads['basedir'], '', $new_path );
! 			$new_path = ltrim( $new_path, '/' );
  	}
  
  	return apply_filters( '_wp_relative_upload_path', $new_path, $path );
***************
*** 372,427 ****
   * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/get_post
   *
!  * @param int|object $post Post ID or post object.
   * @param string $output Optional, default is Object. Either OBJECT, ARRAY_A, or ARRAY_N.
   * @param string $filter Optional, default is raw.
!  * @return mixed Post data
   */
! function &get_post(&$post, $output = OBJECT, $filter = 'raw') {
! 	global $wpdb;
! 	$null = null;
  
! 	if ( empty($post) ) {
! 		if ( isset($GLOBALS['post']) )
! 			$_post = & $GLOBALS['post'];
! 		else
! 			return $null;
! 	} elseif ( is_object($post) && empty($post->filter) ) {
! 		_get_post_ancestors($post);
! 		$_post = sanitize_post($post, 'raw');
! 		wp_cache_add($post->ID, $_post, 'posts');
! 	} elseif ( is_object($post) && 'raw' == $post->filter ) {
  		$_post = $post;
  	} else {
! 		if ( is_object($post) )
! 			$post_id = $post->ID;
! 		else
! 			$post_id = $post;
  
  		$post_id = (int) $post_id;
! 		if ( ! $_post = wp_cache_get($post_id, 'posts') ) {
! 			$_post = $wpdb->get_row($wpdb->prepare("SELECT * FROM $wpdb->posts WHERE ID = %d LIMIT 1", $post_id));
  			if ( ! $_post )
! 				return $null;
! 			_get_post_ancestors($_post);
! 			$_post = sanitize_post($_post, 'raw');
! 			wp_cache_add($_post->ID, $_post, 'posts');
  		}
  	}
  
! 	if ($filter != 'raw')
! 		$_post = sanitize_post($_post, $filter);
  
! 	if ( $output == OBJECT ) {
! 		return $_post;
! 	} elseif ( $output == ARRAY_A ) {
! 		$__post = get_object_vars($_post);
! 		return $__post;
! 	} elseif ( $output == ARRAY_N ) {
! 		$__post = array_values(get_object_vars($_post));
! 		return $__post;
! 	} else {
! 		return $_post;
  	}
  }
  
--- 378,674 ----
   * @uses $wpdb
   * @link http://codex.wordpress.org/Function_Reference/get_post
   *
!  * @param int|object $post Post ID or post object. Optional, default is the current post from the loop.
   * @param string $output Optional, default is Object. Either OBJECT, ARRAY_A, or ARRAY_N.
   * @param string $filter Optional, default is raw.
!  * @return WP_Post|null WP_Post on success or null on failure
   */
! function get_post( $post = null, $output = OBJECT, $filter = 'raw' ) {
! 	if ( empty( $post ) && isset( $GLOBALS['post'] ) )
! 		$post = $GLOBALS['post'];
  
! 	if ( is_a( $post, 'WP_Post' ) ) {
  		$_post = $post;
+ 	} elseif ( is_object( $post ) ) {
+ 		if ( empty( $post->filter ) ) {
+ 			$_post = sanitize_post( $post, 'raw' );
+ 			$_post = new WP_Post( $_post );
+ 		} elseif ( 'raw' == $post->filter ) {
+ 			$_post = new WP_Post( $post );
+ 		} else {
+ 			$_post = WP_Post::get_instance( $post->ID );
+ 		}
  	} else {
! 		$_post = WP_Post::get_instance( $post );
! 	}
! 
! 	if ( ! $_post )
! 		return null;
! 
! 	$_post = $_post->filter( $filter );
! 
! 	if ( $output == ARRAY_A )
! 		return $_post->to_array();
! 	elseif ( $output == ARRAY_N )
! 		return array_values( $_post->to_array() );
! 
! 	return $_post;
! }
! 
! /**
!  * WordPress Post class.
!  *
!  * @since 3.5.0
!  *
!  */
! final class WP_Post {
! 
! 	/**
! 	 *
! 	 * @var int
! 	 */
! 	public $ID;
! 
! 	/**
! 	 *
! 	 * @var int
! 	 */
! 	public $post_author = 0;
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_date = '0000-00-00 00:00:00';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_date_gmt = '0000-00-00 00:00:00';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_content = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_title = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_excerpt = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_status = 'publish';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $comment_status = 'open';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $ping_status = 'open';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_password = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_name = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $to_ping = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $pinged = '';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_modified = '0000-00-00 00:00:00';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_modified_gmt = '0000-00-00 00:00:00';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_content_filtered = '';
! 
! 	/**
! 	 *
! 	 * @var int
! 	 */
! 	public $post_parent = 0;
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $guid = '';
! 
! 	/**
! 	 *
! 	 * @var int
! 	 */
! 	public $menu_order = 0;
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_type = 'post';
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $post_mime_type = '';
! 
! 	/**
! 	 *
! 	 * @var int
! 	 */
! 	public $comment_count = 0;
! 
! 	/**
! 	 *
! 	 * @var string
! 	 */
! 	public $filter;
! 
! 	public static function get_instance( $post_id ) {
! 		global $wpdb;
  
  		$post_id = (int) $post_id;
! 		if ( ! $post_id )
! 			return false;
! 
! 		$_post = wp_cache_get( $post_id, 'posts' );
! 
! 		if ( ! $_post ) {
! 			$_post = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $wpdb->posts WHERE ID = %d LIMIT 1", $post_id ) );
! 
  			if ( ! $_post )
! 				return false;
! 
! 			$_post = sanitize_post( $_post, 'raw' );
! 			wp_cache_add( $_post->ID, $_post, 'posts' );
! 		} elseif ( empty( $_post->filter ) ) {
! 			$_post = sanitize_post( $_post, 'raw' );
  		}
+ 
+ 		return new WP_Post( $_post );
  	}
  
! 	public function __construct( $post ) {
! 		foreach ( get_object_vars( $post ) as $key => $value )
! 			$this->$key = $value;
! 	}
  
! 	public function __isset( $key ) {
! 		if ( 'ancestors' == $key )
! 			return true;
! 
! 		if ( 'page_template' == $key )
! 			return ( 'page' == $this->post_type );
! 
! 		if ( 'post_category' == $key )
! 		   return true;
! 
! 		if ( 'tags_input' == $key )
! 		   return true;
! 
! 		return metadata_exists( 'post', $this->ID, $key );
! 	}
! 
! 	public function __get( $key ) {
! 		if ( 'page_template' == $key && $this->__isset( $key ) ) {
! 			return get_post_meta( $this->ID, '_wp_page_template', true );
! 		}
! 
! 		if ( 'post_category' == $key ) {
! 			if ( is_object_in_taxonomy( $this->post_type, 'category' ) )
! 				$terms = get_the_terms( $this, 'category' );
! 
! 			if ( empty( $terms ) )
! 				return array();
! 
! 			return wp_list_pluck( $terms, 'term_id' );
! 		}
! 
! 		if ( 'tags_input' == $key ) {
! 			if ( is_object_in_taxonomy( $this->post_type, 'post_tag' ) )
! 				$terms = get_the_terms( $this, 'post_tag' );
! 
! 			if ( empty( $terms ) )
! 				return array();
! 
! 			return wp_list_pluck( $terms, 'name' );
! 		}
! 
! 		// Rest of the values need filtering
! 
! 		if ( 'ancestors' == $key )
! 			$value = get_post_ancestors( $this );
! 		else
! 			$value = get_post_meta( $this->ID, $key, true );
! 
! 		if ( $this->filter )
! 			$value = sanitize_post_field( $key, $value, $this->ID, $this->filter );
! 
! 		return $value;
! 	}
! 
! 	public function filter( $filter ) {
! 		if ( $this->filter == $filter )
! 			return $this;
! 
! 		if ( $filter == 'raw' )
! 			return self::get_instance( $this->ID );
! 
! 		return sanitize_post( $this, $filter );
! 	}
! 
! 	public function to_array() {
! 		$post = get_object_vars( $this );
! 
! 		foreach ( array( 'ancestors', 'page_template', 'post_category', 'tags_input' ) as $key ) {
! 			if ( $this->__isset( $key ) )
! 				$post[ $key ] = $this->__get( $key );
! 		}
! 
! 		return $post;
  	}
  }
  
***************
*** 433,448 ****
   * @param int|object $post Post ID or post object
   * @return array Ancestor IDs or empty array if none are found.
   */
! function get_post_ancestors($post) {
! 	$post = get_post($post);
  
! 	if ( ! isset( $post->ancestors ) )
! 		_get_post_ancestors( $post );
  
! 	if ( ! empty( $post->ancestors ) )
! 		return $post->ancestors;
  
! 	return array();
  }
  
  /**
--- 680,707 ----
   * @param int|object $post Post ID or post object
   * @return array Ancestor IDs or empty array if none are found.
   */
! function get_post_ancestors( $post ) {
! 	if ( ! $post )
! 		return false;
  
! 	$post = get_post( $post );
  
! 	if ( empty( $post->post_parent ) || $post->post_parent == $post->ID )
! 		return array();
  
! 	$ancestors = array();
! 
! 	$id = $ancestors[] = $post->post_parent;
! 
! 	while ( $ancestor = get_post( $id ) ) {
! 		// Loop detection: If the ancestor has been seen before, break.
! 		if ( empty( $ancestor->post_parent ) || ( $ancestor->post_parent == $post->ID ) || in_array( $ancestor->post_parent, $ancestors ) )
! 			break;
! 
! 		$id = $ancestors[] = $ancestor->post_parent;
! 	}
! 
! 	return $ancestors;
  }
  
  /**
***************
*** 460,475 ****
   * @param string $field Post field name
   * @param id $post Post ID
   * @param string $context Optional. How to filter the field. Default is display.
!  * @return WP_Error|string Value in post field or WP_Error on failure
   */
  function get_post_field( $field, $post, $context = 'display' ) {
- 	$post = (int) $post;
  	$post = get_post( $post );
  
! 	if ( is_wp_error($post) )
! 		return $post;
! 
! 	if ( !is_object($post) )
  		return '';
  
  	if ( !isset($post->$field) )
--- 719,730 ----
   * @param string $field Post field name
   * @param id $post Post ID
   * @param string $context Optional. How to filter the field. Default is display.
!  * @return bool|string False on failure or returns the value in post field
   */
  function get_post_field( $field, $post, $context = 'display' ) {
  	$post = get_post( $post );
  
! 	if ( !$post )
  		return '';
  
  	if ( !isset($post->$field) )
***************
*** 490,496 ****
   * @return bool|string False on failure or returns the mime type
   */
  function get_post_mime_type($ID = '') {
! 	$post = & get_post($ID);
  
  	if ( is_object($post) )
  		return $post->post_mime_type;
--- 745,751 ----
   * @return bool|string False on failure or returns the mime type
   */
  function get_post_mime_type($ID = '') {
! 	$post = get_post($ID);
  
  	if ( is_object($post) )
  		return $post->post_mime_type;
***************
*** 671,677 ****
  		$wp_post_statuses = array();
  
  	// Args prefixed with an underscore are reserved for internal use.
! 	$defaults = array('label' => false, 'label_count' => false, 'exclude_from_search' => null, '_builtin' => false, '_edit_link' => 'post.php?post=%d', 'capability_type' => 'post', 'hierarchical' => false, 'public' => null, 'internal' => null, 'protected' => null, 'private' => null, 'show_in_admin_all' => null, 'publicly_queryable' => null, 'show_in_admin_status_list' => null, 'show_in_admin_all_list' => null, 'single_view_cap' => null);
  	$args = wp_parse_args($args, $defaults);
  	$args = (object) $args;
  
--- 926,944 ----
  		$wp_post_statuses = array();
  
  	// Args prefixed with an underscore are reserved for internal use.
! 	$defaults = array(
! 		'label' => false,
! 		'label_count' => false,
! 		'exclude_from_search' => null,
! 		'_builtin' => false,
! 		'public' => null,
! 		'internal' => null,
! 		'protected' => null,
! 		'private' => null,
! 		'publicly_queryable' => null,
! 		'show_in_admin_status_list' => null,
! 		'show_in_admin_all_list' => null,
! 	);
  	$args = wp_parse_args($args, $defaults);
  	$args = (object) $args;
  
***************
*** 703,712 ****
  		$args->show_in_admin_all_list = !$args->internal;
  
  	if ( null === $args->show_in_admin_status_list )
! 			$args->show_in_admin_status_list = !$args->internal;
! 
! 	if ( null === $args->single_view_cap )
! 		$args->single_view_cap = $args->public ? '' : 'edit';
  
  	if ( false === $args->label )
  		$args->label = $post_status;
--- 970,976 ----
  		$args->show_in_admin_all_list = !$args->internal;
  
  	if ( null === $args->show_in_admin_status_list )
! 		$args->show_in_admin_status_list = !$args->internal;
  
  	if ( false === $args->label )
  		$args->label = $post_status;
***************
*** 804,822 ****
   *
   * @uses $post The Loop current post global
   *
!  * @param mixed $the_post Optional. Post object or post ID.
   * @return bool|string post type or false on failure.
   */
! function get_post_type( $the_post = false ) {
! 	global $post;
! 
! 	if ( false === $the_post )
! 		$the_post = $post;
! 	elseif ( is_numeric($the_post) )
! 		$the_post = get_post($the_post);
! 
! 	if ( is_object($the_post) )
! 		return $the_post->post_type;
  
  	return false;
  }
--- 1068,1079 ----
   *
   * @uses $post The Loop current post global
   *
!  * @param mixed $post Optional. Post object or post ID.
   * @return bool|string post type or false on failure.
   */
! function get_post_type( $post = null ) {
! 	if ( $post = get_post( $post ) )
! 		return $post->post_type;
  
  	return false;
  }
***************
*** 1020,1026 ****
  	if ( ! empty($args->supports) ) {
  		add_post_type_support($post_type, $args->supports);
  		unset($args->supports);
! 	} else {
  		// Add default features
  		add_post_type_support($post_type, array('title', 'editor'));
  	}
--- 1277,1283 ----
  	if ( ! empty($args->supports) ) {
  		add_post_type_support($post_type, $args->supports);
  		unset($args->supports);
! 	} elseif ( false !== $args->supports ) {
  		// Add default features
  		add_post_type_support($post_type, array('title', 'editor'));
  	}
***************
*** 1028,1034 ****
  	if ( false !== $args->query_var && !empty($wp) ) {
  		if ( true === $args->query_var )
  			$args->query_var = $post_type;
! 		$args->query_var = sanitize_title_with_dashes($args->query_var);
  		$wp->add_query_var($args->query_var);
  	}
  
--- 1285,1292 ----
  	if ( false !== $args->query_var && !empty($wp) ) {
  		if ( true === $args->query_var )
  			$args->query_var = $post_type;
! 		else
! 			$args->query_var = sanitize_title_with_dashes($args->query_var);
  		$wp->add_query_var($args->query_var);
  	}
  
***************
*** 1182,1187 ****
--- 1440,1449 ----
  
  	$capabilities = array_merge( $default_capabilities, $args->capabilities );
  
+ 	// Post creation capability simply maps to edit_posts by default:
+ 	if ( ! isset( $capabilities['create_posts'] ) )
+ 		$capabilities['create_posts'] = $capabilities['edit_posts'];
+ 
  	// Remember meta capabilities for future reference.
  	if ( $args->map_meta_cap )
  		_post_type_meta_capabilities( $capabilities );
***************
*** 1245,1251 ****
  		'all_items' => array( __( 'All Posts' ), __( 'All Pages' ) )
  	);
  	$nohier_vs_hier_defaults['menu_name'] = $nohier_vs_hier_defaults['name'];
! 	return _get_custom_object_labels( $post_type_object, $nohier_vs_hier_defaults );
  }
  
  /**
--- 1507,1517 ----
  		'all_items' => array( __( 'All Posts' ), __( 'All Pages' ) )
  	);
  	$nohier_vs_hier_defaults['menu_name'] = $nohier_vs_hier_defaults['name'];
! 
! 	$labels = _get_custom_object_labels( $post_type_object, $nohier_vs_hier_defaults );
! 
! 	$post_type = $post_type_object->name;
! 	return apply_filters( "post_type_labels_{$post_type}", $labels );
  }
  
  /**
***************
*** 1668,1676 ****
   * @since 2.3.0
   * @uses sanitize_post_field() Used to sanitize the fields.
   *
!  * @param object|array $post The Post Object or Array
   * @param string $context Optional, default is 'display'. How to sanitize post fields.
!  * @return object|array The now sanitized Post Object or Array (will be the same type as $post)
   */
  function sanitize_post($post, $context = 'display') {
  	if ( is_object($post) ) {
--- 1934,1942 ----
   * @since 2.3.0
   * @uses sanitize_post_field() Used to sanitize the fields.
   *
!  * @param object|WP_Post|array $post The Post Object or Array
   * @param string $context Optional, default is 'display'. How to sanitize post fields.
!  * @return object|WP_Post|array The now sanitized Post Object or Array (will be the same type as $post)
   */
  function sanitize_post($post, $context = 'display') {
  	if ( is_object($post) ) {
***************
*** 1917,1922 ****
--- 2183,2205 ----
  }
  
  /**
+  * Get default post mime types
+  *
+  * @since 2.9.0
+  *
+  * @return array
+  */
+ function get_post_mime_types() {
+ 	$post_mime_types = array(	//	array( adj, noun )
+ 		'image' => array(__('Images'), __('Manage Images'), _n_noop('Image <span class="count">(%s)</span>', 'Images <span class="count">(%s)</span>')),
+ 		'audio' => array(__('Audio'), __('Manage Audio'), _n_noop('Audio <span class="count">(%s)</span>', 'Audio <span class="count">(%s)</span>')),
+ 		'video' => array(__('Video'), __('Manage Video'), _n_noop('Video <span class="count">(%s)</span>', 'Video <span class="count">(%s)</span>')),
+ 	);
+ 
+ 	return apply_filters('post_mime_types', $post_mime_types);
+ }
+ 
+ /**
   * Check a MIME-Type against a list.
   *
   * If the wildcard_mime_types parameter is a string, it must be comma separated
***************
*** 2086,2093 ****
  
  	clean_post_cache( $post );
  
! 	if ( is_post_type_hierarchical( $post->post_type ) ) {
! 		foreach ( (array) $children as $child )
  			clean_post_cache( $child );
  	}
  
--- 2369,2376 ----
  
  	clean_post_cache( $post );
  
! 	if ( is_post_type_hierarchical( $post->post_type ) && $children ) {
! 		foreach ( $children as $child )
  			clean_post_cache( $child );
  	}
  
***************
*** 2115,2121 ****
  	if ( !EMPTY_TRASH_DAYS )
  		return wp_delete_post($post_id, true);
  
! 	if ( !$post = wp_get_single_post($post_id, ARRAY_A) )
  		return $post;
  
  	if ( $post['post_status'] == 'trash' )
--- 2398,2404 ----
  	if ( !EMPTY_TRASH_DAYS )
  		return wp_delete_post($post_id, true);
  
! 	if ( !$post = get_post($post_id, ARRAY_A) )
  		return $post;
  
  	if ( $post['post_status'] == 'trash' )
***************
*** 2147,2153 ****
   * @return mixed False on failure
   */
  function wp_untrash_post($post_id = 0) {
! 	if ( !$post = wp_get_single_post($post_id, ARRAY_A) )
  		return $post;
  
  	if ( $post['post_status'] != 'trash' )
--- 2430,2436 ----
   * @return mixed False on failure
   */
  function wp_untrash_post($post_id = 0) {
! 	if ( !$post = get_post($post_id, ARRAY_A) )
  		return $post;
  
  	if ( $post['post_status'] != 'trash' )
***************
*** 2378,2426 ****
  }
  
  /**
-  * Retrieve a single post, based on post ID.
-  *
-  * Has categories in 'post_category' property or key. Has tags in 'tags_input'
-  * property or key.
-  *
-  * @since 1.0.0
-  *
-  * @param int $postid Post ID.
-  * @param string $mode How to return result, either OBJECT, ARRAY_N, or ARRAY_A.
-  * @return object|array Post object or array holding post contents and information
-  */
- function wp_get_single_post($postid = 0, $mode = OBJECT) {
- 	$postid = (int) $postid;
- 
- 	$post = get_post($postid, $mode);
- 
- 	if (
- 		( OBJECT == $mode && empty( $post->ID ) ) ||
- 		( OBJECT != $mode && empty( $post['ID'] ) )
- 	)
- 		return ( OBJECT == $mode ? null : array() );
- 
- 	// Set categories and tags
- 	if ( $mode == OBJECT ) {
- 		$post->post_category = array();
- 		if ( is_object_in_taxonomy($post->post_type, 'category') )
- 			$post->post_category = wp_get_post_categories($postid);
- 		$post->tags_input = array();
- 		if ( is_object_in_taxonomy($post->post_type, 'post_tag') )
- 			$post->tags_input = wp_get_post_tags($postid, array('fields' => 'names'));
- 	} else {
- 		$post['post_category'] = array();
- 		if ( is_object_in_taxonomy($post['post_type'], 'category') )
- 			$post['post_category'] = wp_get_post_categories($postid);
- 		$post['tags_input'] = array();
- 		if ( is_object_in_taxonomy($post['post_type'], 'post_tag') )
- 			$post['tags_input'] = wp_get_post_tags($postid, array('fields' => 'names'));
- 	}
- 
- 	return $post;
- }
- 
- /**
   * Insert a post.
   *
   * If the $postarr parameter has 'ID' set to a value, then post will be updated.
--- 2661,2666 ----
***************
*** 2547,2552 ****
--- 2787,2804 ----
  	if ( empty($post_date) || '0000-00-00 00:00:00' == $post_date )
  		$post_date = current_time('mysql');
  
+ 		// validate the date
+ 		$mm = substr( $post_date, 5, 2 );
+ 		$jj = substr( $post_date, 8, 2 );
+ 		$aa = substr( $post_date, 0, 4 );
+ 		$valid_date = wp_checkdate( $mm, $jj, $aa, $post_date );
+ 		if ( !$valid_date ) {
+ 			if ( $wp_error )
+ 				return new WP_Error( 'invalid_date', __( 'Whoops, the provided date is invalid.' ) );
+ 			else
+ 				return 0;
+ 		}
+ 
  	if ( empty($post_date_gmt) || '0000-00-00 00:00:00' == $post_date_gmt ) {
  		if ( !in_array( $post_status, array( 'draft', 'pending', 'auto-draft' ) ) )
  			$post_date_gmt = get_gmt_from_date($post_date);
***************
*** 2667,2684 ****
  
  	$current_guid = get_post_field( 'guid', $post_ID );
  
- 	clean_post_cache( $post_ID );
- 
  	// Set GUID
  	if ( !$update && '' == $current_guid )
  		$wpdb->update( $wpdb->posts, array( 'guid' => get_permalink( $post_ID ) ), $where );
  
  	$post = get_post($post_ID);
  
  	if ( !empty($page_template) && 'page' == $data['post_type'] ) {
  		$post->page_template = $page_template;
! 		$page_templates = get_page_templates();
! 		if ( 'default' != $page_template && !in_array($page_template, $page_templates) ) {
  			if ( $wp_error )
  				return new WP_Error('invalid_page_template', __('The page template is invalid.'));
  			else
--- 2919,2936 ----
  
  	$current_guid = get_post_field( 'guid', $post_ID );
  
  	// Set GUID
  	if ( !$update && '' == $current_guid )
  		$wpdb->update( $wpdb->posts, array( 'guid' => get_permalink( $post_ID ) ), $where );
  
+ 	clean_post_cache( $post_ID );
+ 
  	$post = get_post($post_ID);
  
  	if ( !empty($page_template) && 'page' == $data['post_type'] ) {
  		$post->page_template = $page_template;
! 		$page_templates = wp_get_theme()->get_page_templates();
! 		if ( 'default' != $page_template && ! isset( $page_templates[ $page_template ] ) ) {
  			if ( $wp_error )
  				return new WP_Error('invalid_page_template', __('The page template is invalid.'));
  			else
***************
*** 2710,2718 ****
   * @since 1.0.0
   *
   * @param array|object $postarr Post data. Arrays are expected to be escaped, objects are not.
!  * @return int 0 on failure, Post ID on success.
   */
! function wp_update_post($postarr = array()) {
  	if ( is_object($postarr) ) {
  		// non-escaped post was passed
  		$postarr = get_object_vars($postarr);
--- 2962,2971 ----
   * @since 1.0.0
   *
   * @param array|object $postarr Post data. Arrays are expected to be escaped, objects are not.
!  * @param bool $wp_error Optional. Allow return of WP_Error on failure.
!  * @return int|WP_Error The value 0 or WP_Error on failure. The post ID on success.
   */
! function wp_update_post( $postarr = array(), $wp_error = false ) {
  	if ( is_object($postarr) ) {
  		// non-escaped post was passed
  		$postarr = get_object_vars($postarr);
***************
*** 2720,2726 ****
  	}
  
  	// First, get all of the original fields
! 	$post = wp_get_single_post($postarr['ID'], ARRAY_A);
  
  	// Escape data pulled from DB.
  	$post = add_magic_quotes($post);
--- 2973,2979 ----
  	}
  
  	// First, get all of the original fields
! 	$post = get_post($postarr['ID'], ARRAY_A);
  
  	// Escape data pulled from DB.
  	$post = add_magic_quotes($post);
***************
*** 2750,2776 ****
  	if ($postarr['post_type'] == 'attachment')
  		return wp_insert_attachment($postarr);
  
! 	return wp_insert_post($postarr);
  }
  
  /**
   * Publish a post by transitioning the post status.
   *
   * @since 2.1.0
!  * @uses $wpdb
!  * @uses do_action() Calls 'edit_post', 'save_post', and 'wp_insert_post' on post_id and post data.
   *
!  * @param int $post_id Post ID.
!  * @return null
   */
! function wp_publish_post($post_id) {
! 	global $wpdb;
! 
! 	$post = get_post($post_id);
! 
! 	if ( empty($post) )
  		return;
- 
  	if ( 'publish' == $post->post_status )
  		return;
  
--- 3003,3022 ----
  	if ($postarr['post_type'] == 'attachment')
  		return wp_insert_attachment($postarr);
  
! 	return wp_insert_post( $postarr, $wp_error );
  }
  
  /**
   * Publish a post by transitioning the post status.
   *
   * @since 2.1.0
!  * @uses wp_update_post()
   *
!  * @param mixed $post Post ID or object.
   */
! function wp_publish_post( $post ) {
! 	if ( ! $post = get_post( $post ) )
  		return;
  	if ( 'publish' == $post->post_status )
  		return;
  
***************
*** 2774,2788 ****
  	if ( 'publish' == $post->post_status )
  		return;
  
- 	$wpdb->update( $wpdb->posts, array( 'post_status' => 'publish' ), array( 'ID' => $post_id ) );
- 
- 	$old_status = $post->post_status;
  	$post->post_status = 'publish';
! 	wp_transition_post_status('publish', $old_status, $post);
! 
! 	do_action('edit_post', $post_id, $post);
! 	do_action('save_post', $post_id, $post);
! 	do_action('wp_insert_post', $post_id, $post);
  }
  
  /**
--- 3020,3027 ----
  	if ( 'publish' == $post->post_status )
  		return;
  
  	$post->post_status = 'publish';
! 	wp_update_post( $post );
  }
  
  /**
***************
*** 2837,2842 ****
--- 3076,3083 ----
  
  	global $wpdb, $wp_rewrite;
  
+ 	$original_slug = $slug;
+ 
  	$feeds = $wp_rewrite->feeds;
  	if ( ! is_array( $feeds ) )
  		$feeds = array();
***************
*** 2857,2862 ****
--- 3098,3105 ----
  			$slug = $alt_post_name;
  		}
  	} elseif ( in_array( $post_type, $hierarchical_post_types ) ) {
+ 		if ( 'nav_menu_item' == $post_type )
+ 			return $slug;
  		// Page slugs must be unique within their own trees. Pages are in a separate
  		// namespace than posts so page slugs are allowed to overlap post slugs.
  		$check_sql = "SELECT post_name FROM $wpdb->posts WHERE post_name = %s AND post_type IN ( '" . implode( "', '", esc_sql( $hierarchical_post_types ) ) . "' ) AND ID != %d AND post_parent = %d LIMIT 1";
***************
*** 2887,2893 ****
  		}
  	}
  
! 	return apply_filters( 'wp_unique_post_slug', $slug, $post_ID, $post_status, $post_type, $post_parent );
  }
  
  /**
--- 3130,3136 ----
  		}
  	}
  
! 	return apply_filters( 'wp_unique_post_slug', $slug, $post_ID, $post_status, $post_type, $post_parent, $original_slug );
  }
  
  /**
***************
*** 2953,2963 ****
  	// Hierarchical taxonomies must always pass IDs rather than names so that children with the same
  	// names but different parents aren't confused.
  	if ( is_taxonomy_hierarchical( $taxonomy ) ) {
! 		$tags = array_map( 'intval', $tags );
! 		$tags = array_unique( $tags );
  	}
  
! 	return wp_set_object_terms($post_id, $tags, $taxonomy, $append);
  }
  
  /**
--- 3196,3205 ----
  	// Hierarchical taxonomies must always pass IDs rather than names so that children with the same
  	// names but different parents aren't confused.
  	if ( is_taxonomy_hierarchical( $taxonomy ) ) {
! 		$tags = array_unique( array_map( 'intval', $tags ) );
  	}
  
! 	return wp_set_object_terms( $post_id, $tags, $taxonomy, $append );
  }
  
  /**
***************
*** 2986,2997 ****
  		return true;
  	}
  
! 	if ( !empty($post_categories) ) {
! 		$post_categories = array_map('intval', $post_categories);
! 		$post_categories = array_unique($post_categories);
! 	}
! 
! 	return wp_set_object_terms($post_ID, $post_categories, 'category');
  }
  
  /**
--- 3228,3234 ----
  		return true;
  	}
  
! 	return wp_set_post_terms($post_ID, $post_categories, 'category');
  }
  
  /**
***************
*** 3127,3133 ****
  function trackback_url_list($tb_list, $post_id) {
  	if ( ! empty( $tb_list ) ) {
  		// get post data
! 		$postdata = wp_get_single_post($post_id, ARRAY_A);
  
  		// import postdata as variables
  		extract($postdata, EXTR_SKIP);
--- 3364,3370 ----
  function trackback_url_list($tb_list, $post_id) {
  	if ( ! empty( $tb_list ) ) {
  		// get post data
! 		$postdata = get_post($post_id, ARRAY_A);
  
  		// import postdata as variables
  		extract($postdata, EXTR_SKIP);
